//+------------------------------------------------------------------+
//|                                          Guppy MMA oscilator.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_buffers 2
#property indicator_color1  Green
#property indicator_color2  Red

//
//
//
//
//

extern int   Price                 = PRICE_CLOSE;
extern int   SignalPeriod          = 9;
extern bool  ShowArrowsOnZeroCross = false;


//
//
//
//
//

extern bool  alertsOn             = false;
extern bool  alertsOnCurrent      = true;
extern bool  alertsMessage        = true;
extern bool  alertsSound          = false;
extern bool  alertsEmail          = false;

//
//
//
//
//

double upBuffer[];
double dnBuffer[];
double buffer1[];
double buffer2[];
double trend[];
double periods[]={3,5,8,10,12,15,30,35,40,45,50,60};
int    persize;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,upBuffer);  SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,108);
   SetIndexBuffer(1,dnBuffer);  SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,108);
   SetIndexBuffer(2,buffer1);
   SetIndexBuffer(3,buffer2);
   SetIndexBuffer(4,trend);
   persize =ArraySize(periods);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   double alpha = 2.0/(1.0+SignalPeriod);
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      double sum  = 0;
      for(int j=0; j<persize; j++)
      {
         if (periods[j]<30)
               sum  += iMA(NULL,0,periods[j],0,MODE_EMA,Price,i);
         else  sum  -= iMA(NULL,0,periods[j],0,MODE_EMA,Price,i);
      }
      buffer1[i] = sum*10.0;
      buffer2[i] = buffer2[i+1]+alpha*(buffer1[i]-buffer2[i+1]);
      
      //
      //
      //
      //
      //
      
         upBuffer[i]  = EMPTY_VALUE;
         dnBuffer[i]  = EMPTY_VALUE;
         trend[i]     = trend[i+1];
         if (ShowArrowsOnZeroCross)
         {
            if (buffer1[i]>0) trend[i]= 1;
            if (buffer1[i]<0) trend[i]=-1;
         }
         else                     
         {
            if (buffer1[i]>buffer2[i]) trend[i]= 1;
            if (buffer1[i]<buffer2[i]) trend[i]=-1;
         }
         if (trend[i] != trend[i+1])
         {
            if (trend[i] ==  1) upBuffer[i] = Low[i]-iATR(NULL,0,20,i);
            if (trend[i] == -1) dnBuffer[i] = High[i]+iATR(NULL,0,20,i);
         }            
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[i] == 1)
            doAlert("up");
      else  doAlert("down");
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," GMMA trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"GMMA "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}